#include "otabrowse5.h"
#pragma hdrstop

#include "resourceentry.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TResourceEntryForm *ResourceEntryForm;
//---------------------------------------------------------------------------
__fastcall TResourceEntryForm::TResourceEntryForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TResourceEntryForm::FormShow(TObject *Sender)
{ bGet->Click();
  cbHeaderValue->ItemIndex=0;
  tHandle->Caption=AnsiString("0x")+IntToHex((int)re->GetEntryHandle(),8);
  bGetData->Click();
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::bGetClick(TObject *Sender)
{ eName->Text=ResourceNameToString(re->GetResourceName());
  cbType->Text=ResourceTypeToString(re->GetResourceType());
}
//---------------------------------------------------------------------------

void __fastcall TResourceEntryForm::bGetHeaderValueClick(TObject *Sender)
{ TOTAResHeaderValue hv;
  int i=cbHeaderValue->ItemIndex;
  if (i==0) hv=hvFlags;
  else if (i==1) hv=hvLanguage;
  else if (i==2) hv=hvDataVersion;
  else if (i==3) hv=hvVersion;
  else if (i==4) hv=hvCharacteristics;
  else {MessageBeep(0);return;}
  int val;
  bool res=re->GetHeaderValue(hv,val);
  if (res) eHeaderValue->Text="0x"+IntToHex(val,8);
  else eHeaderValue->Text="<error>";
}
//---------------------------------------------------------------------------

void __fastcall TResourceEntryForm::bSetHeaderValueClick(TObject *Sender)
{ TOTAResHeaderValue hv;
  int i=cbHeaderValue->ItemIndex;
  if (i==0) hv=hvFlags;
  else if (i==1) hv=hvLanguage;
  else if (i==2) hv=hvDataVersion;
  else if (i==3) hv=hvVersion;
  else if (i==4) hv=hvCharacteristics;
  else {MessageBeep(0);return;}
  int val;
  try {val=eHeaderValue->Text.ToInt();} catch (EConvertError &err) {MessageBeep(0);return;}
  bool res=re->SetHeaderValue(hv,val);
  if (!res) {Application->MessageBox("Error setting header value","Error",MB_OK);return;}
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::bChangeClick(TObject *Sender)
{ char *name=ResourceNameFromString(eName->Text);
  char *type=ResourceTypeFromString(cbType->Text);
  if (type==NULL || name==NULL) {MessageBeep(0);return;}
  bool res=re->Change(type,name);
  if (!res) {Application->MessageBox("Error changing resource entry","Change",MB_OK);return;}
  bGetData->Click();
}
//---------------------------------------------------------------------------

void __fastcall TResourceEntryForm::bSetDataClick(TObject *Sender)
{ bool res=SetDataDialog->Execute();
  if (!res) return;
  AnsiString fn=SetDataDialog->FileName;
  TFileStream *fs=new TFileStream(fn,fmOpenRead|fmShareDenyWrite);
  re->SetDataSize(fs->Size);
  fs->ReadBuffer(re->GetData(),fs->Size);
  delete fs;
}
//---------------------------------------------------------------------------


void __fastcall TResourceEntryForm::bGetDataClick(TObject *Sender)
{ char *data=(char*)re->GetData(); int size=re->GetDataSize(); char *type=re->GetResourceType();
  tSize->Caption=AnsiString(size);
  if (type==RT_BITMAP && size>sizeof(TBitmapCoreHeader))
  { // Bitmaps need a header added before TBitmap can stream them in
    TBitmapFileHeader bfh; bfh.bfType=0x4D42;
    TBitmapInfoHeader *bih=(TBitmapInfoHeader*)data;
    if (bih->biSize==sizeof(TBitmapCoreHeader))
    { int ncolors = 1 << (bih->biPlanes*bih->biBitCount);
      bfh.bfOffBits=bih->biSize+ncolors*sizeof(RGBQUAD);
      // Lischner: pad to a long word boundary
      bfh.bfSize = sizeof(bfh) + bfh.bfOffBits + ((bih->biWidth+3)/2)*2 * bih->biHeight;
    }
    else
    { int ncolors;
      if (bih->biClrUsed!=0 || bih->biBitCount>=16) ncolors=bih->biClrUsed;
      else ncolors = 1 << (bih->biPlanes*bih->biBitCount);
      bfh.bfOffBits = bih->biSize+ncolors*sizeof(RGBQUAD);
      // Lischner: If the image is compressed, biSizeImage contains the number
      // of bytes in the compressed image. For uncompressed images, biSizeImage is usually 0,
      // so compute the size. Scan lines are padded to long word boundaries.
      int h=bih->biHeight; if (h<0) h=-h;
      if (bih->biSizeImage==0) bfh.bfSize=sizeof(bfh) + bfh.bfOffBits + ((bih->biWidth+3)/2)*2 * h;
      else bfh.bfSize = sizeof(bfh) + bfh.bfOffBits + bih->biSizeImage;
    }
    // We'll construct this new thing in a TMemoryStream
    TMemoryStream *ms=new TMemoryStream();
    ms->WriteBuffer(&bfh,sizeof(bfh)); ms->WriteBuffer(data,size); ms->Position=0;
    imgData->Stretch=true;
    imgData->Picture->Bitmap->LoadFromStream(ms);
    delete ms;
    imgData->Visible=true;
    mData->Visible=false;
  }
  else if (type==RT_ICON || type==RT_CURSOR || type==RT_ANICURSOR)
  { imgData->Stretch=false;
    imgData->Picture->Icon->Handle=CreateIconFromResource(data,size,type==RT_ICON,0x30000);
    imgData->Visible=true;
    mData->Visible=false;
  }
  else
  { char *dst=new char[size*2];
    int di=0;
    for (int i=0; i<size; i++)
    { unsigned char byte=data[i];
      if (byte<32 || byte>127) byte='.';
      dst[di]=byte; di++;
      if ((di%44)==0)
      { dst[di]='\r';di++;dst[di]='\n';di++;
      }
    }
    dst[di]=0;
    mData->Lines->Text=AnsiString(dst);
    delete[] dst;
    imgData->Visible=false;
    mData->Visible=true;
  }
}

//---------------------------------------------------------------------------


