#ifndef sampleH
#define sampleH


// TWatcher -- a sample component to show off the various features:
// (1) A property FarForm which contains the name of another form in the project
// (2) A property FarComponent which points to a component on another form
// (3) A 'swapper' to swap the component as soon as it's placed on the form.
// See the implementation file sample.cpp for more details.
// Note: The FarForm property is really just a string, but BCB doesn't
// let us use property-editors for strings. So instead we create a dummy
// thing called a TDummyString to contain the string. And therefore we
// need to create our own TDummyStringPropertyEditor for it as well. Sigh.

class PACKAGE TDummyString : public TPersistent
{ public:    AnsiString FVal;
__published: __property AnsiString Val = {read=FVal,write=FVal};
};


class PACKAGE TWatcher : public TComponent
{
public:
  virtual __fastcall TWatcher(TComponent *Owner);
  virtual __fastcall ~TWatcher();
protected:
  TDummyString *FFarForm; void __fastcall SetFarForm(TDummyString *ofc);
  TComponent *FFarComponent; void __fastcall SetFarComponent(TComponent *c);
  void __fastcall Notification(TComponent *com,TOperation op);
__published:
  __property TDummyString *FarForm = {read=FFarForm,write=SetFarForm};
  __property TComponent *FarComponent = {read=FFarComponent,write=SetFarComponent};
};




#endif
